'demo of draw.dll in Liberty BASIC 3 
'April 10, 2002 - by Alyce Watson
'Use information freely in your own programs.
'Please do not redistribute this file.
'
'DLL information:
'Created by the KPD-Team 1999
'Kris & Pieter Philippaerts
'URL: http://users.turboline.be/btl10148/
'E-Mail: KPD_Team@Hotmail.com

'This demo creates three square boxes for display.
'The boxes are 200x200.  Change *boxsize* at top
'of code to alter size.  If you make size bigger,
'you will need to relocate graphicboxes and
'increase size of window.

nomainwin
boxsize=198
WindowWidth=630:WindowHeight=280
menu #1, "&File","&EarthQuake",[earthquake],_
    "&Mix Pictures",[mix],"&DuoTone",[duotone],_
    "&Gradient",[gradient],"&Pixelate",[pixelate],_
    "&Dither",[dither],"&Brightness",[brightness],_
    "&Rotate",[rotate],"&Get RGB",[rgb],_
    "Bitmap to Region",[bitmaptoregion],"&Shade Rectangle",[shaderect],_
    "Dra&w Pattern",[drawpattern],"&Invert Picture",[invertpicture],_
    "&Create Mask",[createmask],"&Transblt",[transblt],_
    "Change Pi&xels",[changepixels],"Draw &Inverted Bitmap",_
    [drawinvertedbitmap],"E&xit",[quit]

graphicbox #1.src,5,5,boxsize+2,boxsize+2
statictext #1, "Source",5,210,180,30
graphicbox #1.dest,210,5,boxsize+2,boxsize+2
statictext #1, "Destination",215,210,180,30
graphicbox #1.mix,415,5,boxsize+2,boxsize+2
statictext #1, "Mixer",429,210,180,30

open "Draw.DLL Demo" for window_nf as #1
print #1.src, "trapclose [quit]"
print #1.src, "down;fill darkblue;color white"
print #1.src, "backcolor darkpink;size 5"
print #1.src, "place 100 100;circlefilled 80"
print #1.src, "color yellow;font arial 0 30"
print #1.src, "place 55 105"
print #1.src, "\Sample!"
print #1.src, "flush"
print #1.mix, "down;fill pink;color cyan"
print #1.mix, "backcolor darkcyan;place 10 80"
print #1.mix, "size 10;boxfilled 190 120;flush"
print #1.dest,"down"

hwndMain=hwnd(#1)

hSrc=GetDC(hwnd(#1.src))
hDest=GetDC(hwnd(#1.dest))
hMix=GetDC(hwnd(#1.mix))

open "draw.dll" for dll as #d

print #1.src, "getbmp demo 0 0 ";boxsize;" ";boxsize
hbSrc=hbmp("demo")

wait

[quit]
unloadbmp "demo"
call ReleaseDC hwnd(#1.src),hSrc
call ReleaseDC hwnd(#1.dest),hDest
call ReleaseDC hwnd(#1.mix),hMix
close #d:close #1:end

[earthquake]
    print #1.dest, "fill white"
    r=EarthQuake(hSrc,boxsize,boxsize,11,hDest)
    wait

[mix]
     print #1.dest, "fill white"
    r=MixPictures(hSrc,boxsize,boxsize,hMix,boxsize,boxsize,hDest)
    wait

[duotone]
    print #1.dest, "cls"
    DuoColor=(220*256*256)+(220*256)+255
    r=DuoTone(hSrc,boxsize,boxsize,DuoColor,hDest)
    wait

[gradient]
    print #1.dest, "fill white"
    r=GradientFill(hDest,boxsize,boxsize,1,1,0,50)
    wait

[pixelate]
    print #1.dest, "fill white"
    r=Pixelate(hSrc,boxsize,boxsize,3,hDest)
    wait

[dither]
    print #1.dest, "fill white"
    r=DitherBlt(hDest,0,0,boxsize,boxsize,hbSrc,0,0)
    wait

[brightness]
    print #1.dest, "fill white"
    r=Brightness(hSrc,boxsize,boxsize,150,150,150,hDest)
    wait

[rotate]
    print #1.dest, "fill white"
    r=Rotate(hSrc,boxsize,boxsize,45,0,hDest)
    rwide=GetRotatedWidth(boxsize,boxsize,45)
    rhigh=GetRotatedHeight(boxsize,boxsize,45)
    notice "Needed dimensions are ";rwide;" x ";rhigh
    wait

[rgb]
    aColor=(120*256*256)+(140*256)+55
    red=GetR(aColor)
    green=GetG(aColor)
    blue=GetB(aColor)
    notice "Sample RGB values are ";red;" ";green;" ";blue
    'should be 55-140-120
    wait

[bitmaptoregion]
    notice "Warning!  This clips the whole window into a bitmap region."
    tColor=(128*256*256)    'dark blue
    print #1.dest, "fill white"
    hReg=BitmapToRegion(hbSrc,tColor,0)
    calldll #user32, "SetWindowRgn",hwndMain as long, hReg as long,_
        1 as long, result as long
    wait

[shaderect]
    tColor=(128*256*256)    'dark blue
    print #1.dest, "fill white;drawbmp demo 0 0"
    r=ShadeRect(hDest,boxsize,boxsize,1,tColor)
    wait

[drawpattern]
    mColor=(255*256) + 255    'yellow
    invert=0    'invert mask, 1=yes, 0=no
    print #1.dest, "fill white"
    r=DrawPattern(hSrc,boxsize,boxsize,hMix,mColor,hDest,invert)
    wait

[invertpicture]
    print #1.dest, "drawbmp demo 0 0"
    r=InvertPicture(hDest,boxsize,boxsize)
    wait

[createmask]
    mColor=(128*256*256)    'dark blue
    print #1.dest, "fill white"
    r=CreateMask(hSrc,boxsize,boxsize,hDest,mColor)
    wait

[transblt]
    mColor=(128*256*256)    'dark blue
    print #1.dest, "fill white"
    r=TransBlt(hSrc,boxsize,boxsize,mColor,hMix,hDest)
    wait

[changepixels]
    oColor=(128*256*256)    'dark blue original color
    nColor=(140*256*256)+(200*256)+255  'new color=orange
    print #1.dest, "fill white"
    r=ChangePixels(hSrc,boxsize,boxsize,oColor,nColor,hDest)
    wait

[drawinvertedbitmap]
    print #1.dest, "fill white"
    r=DrawInvertedBitmap(hSrc,boxsize,boxsize,1,1,hDest)
    wait

''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Functions from draw.dll in LB syntax.
'Arguments are self-documented using Hungarian notation.
'h=handle
'l=long
'DC=Device Context
'Src=Source
'Dest=Destination
'nWidth=width
'nHeight=height
'b=boolean
'c=long color value

Function EarthQuake(lhSrcDC,nWidth,nHeight,nSize,lhDestDC)
    calldll #d, "EarthQuake",lhSrcDC As Long,nWidth As Long,nHeight As Long,_
    nSize As Long, lhDestDC As Long, EarthQuake As long
    End Function

Function MixPictures(mDC1,nWidth1,nHeight1,mDC2,nWidth2,nHeight2,hDestDC)
    calldll #d, "MixPictures",mDC1 As Long,nWidth1 As Long,nHeight1 As Long,_
    mDC2 As Long, nWidth2 As Long,nHeight2 As Long,hDestDC As Long,MixPictures as long
    End Function

Function DrawPattern(hSrcDC,nWidth,nHeight,hPatternDC,MaskColor,hDestDC,bInvert)
        'bInvert=1 to invert mask, 0 not invert
        'MaskColor=Color to be replaced by pattern
    calldll #d, "DrawPattern",hSrcDC As Long,nWidth As Long,nHeight As Long,_
        hPatternDC As Long,MaskColor As Long,hDestDC As Long,bInvert As Long,_
        DrawPattern As long
    End Function

Function InvertPicture(hSrcDC,nWidth,nHeight)
    calldll #d, "InvertPicture",hSrcDC As Long,nWidth As Long,nHeight As Long,_
        InvertPicture As long
    End Function

Function DuoTone(hSrcDC,nWidth,nHeight,DuoColor,hDestDC)
    calldll #d, "DuoTone", hSrcDC As Long,nWidth As Long,nHeight As Long,_
    DuoColor As Long,hDestDC As Long,DuoTone as long
    End Function

Function Rotate(hSrcDC,nWidth,nHeight,nDegrees,BkColor,hDestDC)
    calldll #d, "Rotate",hSrcDC As Long,nWidth As Long,nHeight As Long,_
    nDegrees As Long,BkColor As Long, hDestDC As Long,Rotate As Long
    End Function

Function ShadeRect(hSrcDC,nWidth,nHeight,UseTransparentColor,MaskColor)
    calldll #d, "ShadeRect",hSrcDC As Long,nWidth As Long,nHeight As Long,_
    UseTransparentColor As Long,MaskColor As Long,ShadeRect As Long
    End Function

Function TransBlt(hSrcDC,lWidth,lHeight,MaskColor,hBackDC,hDestDC)
    calldll #d, "TransBlt",hSrcDC As Long,lWidth As Long,lHeight As Long,_
    MaskColor As Long,hBackDC As Long,hDestDC As Long,TransBlt As Long
    End Function

Function ChangePixels(hSrcDC,lWidth,lHeight,OldColor,NewColor,hDestDC)
    calldll #d, "ChangePixels",hSrcDC As Long,lWidth As Long,lHeight As Long,_
    OldColor As Long,NewColor As Long,hDestDC As Long,ChangePixels As Long
    End Function

Function DrawInvertedBitmap(hSrcDC,nWidth,nHeight,Horizontal,Vertical,hDestDC)
    calldll #d, "DrawInvertedBitmap",hSrcDC As Long,nWidth As Long,nHeight As Long,_
    Horizontal As Boolean,Vertical As Boolean,hDestDC As Long,_
    DrawInvertedBitmap As Long
    End Function

Function GetRotatedWidth(nWidth,nHeight,Degrees)
    calldll #d, "GetRotatedWidth",nWidth As Long,nHeight As Long,_
    Degrees As Long, GetRotatedWidth As Long
    End Function

Function GetRotatedHeight(nWidth,nHeight,Degrees)
    calldll #d, "GetRotatedWidth",nWidth As Long,nHeight As Long,_
    Degrees As Long, GetRotatedHeight As Long
    End Function

Function GradientFill(hDestDC,nWidth,nHeight,R,G,B,nSteps)
    'R,G,B - 1=use, 0=don't use
    calldll #d, "GradientFill",hDestDC As Long,nWidth As Long,nHeight As Long,_
    R As Long,G As Long,B As Long,nSteps As Long, GradientFill As Long
    End Function

Function Pixelate(lhSrcDC,nWidth,nHeight,nSize,lhDestDC)
    calldll #d, "Pixelate", lhSrcDC As Long,nWidth As Long,nHeight As Long,_
    nSize As Long,lhDestDC As Long, Pixelate As Long
    End Function

Function Brightness(hSrcDC,nWidth,nHeight,R,G,B,hDestDC)
    'R,G,B = percent brighter, can be negative
    calldll #d, "Brightness",hSrcDC As Long,nWidth As Long,nHeight As Long,_
    R As Long,G As Long,B As Long,hDestDC As Long,Brightness As Long
    End Function

Function DitherBlt(hdcDest,nXDest,nYDest,nWidth,nHeight,hbm,nXSrc,nYSrc)
    calldll #d, "DitherBlt",hdcDest As Long,nXDest As Long,nYDest As Long,_
    nWidth As Long,nHeight As Long,hbm As Long,nXSrc As Long,nYSrc As Long,DitherBlt As Long
    End Function

Function BitmapToRegion(hBmp,cTransparentColor,cTolerance)
    calldll #d, "BitmapToRegion", hBmp As Long,cTransparentColor As Long,_
    cTolerance As Long,BitmapToRegion As Long
    End Function

Function CreateMask(lhSrcDC,nWidth,nHeight,lhDestDC,MaskColor)
    calldll #d, "CreateMask",lhSrcDC As Long,nWidth As Long,nHeight As Long,_
    lhDestDC As Long,MaskColor As Long,CreateMask as long
    End Function

Function GetR(nColor)
    calldll #d, "GetR",nColor as long,GetR as long
    End Function

Function GetG(nColor)
    calldll #d, "GetG",nColor as long,GetG as long
    End Function

Function GetB(nColor)
    calldll #d, "GetB",nColor as long,GetB as long
    End Function

''''''''''''''''''''''''''''''
'Windows GDI Functions

Function GetDC(hWnd)
    CallDLL #user32, "GetDC",hWnd As long,GetDC As long
    End Function

Sub ReleaseDC hWnd, hDC
    CallDLL#user32,"ReleaseDC",hWnd As long,hDC As long,result As long
    End Sub

